Next: fsetpos, Previous: freopen, Up: Stdio

### 4.26 `fseek`, `fseeko`—set file position

Synopsis

         #include <stdio.h>
         int fseek(FILE *fp, long offset, int whence)
         int fseeko(FILE *fp, off_t offset, int whence)
         int _fseek_r(struct _reent *ptr, FILE *fp,
             long offset, int whence)
         int _fseeko_r(struct _reent *ptr, FILE *fp,
             off_t offset, int whence)

Description
Objects of type `FILE` can have a “position” that records how much of the file your program has already read. Many of the `stdio` functions depend on this position, and many change it as a side effect.

You can use `fseek`/`fseeko` to set the position for the file identified by fp. The value of offset determines the new position, in one of three ways selected by the value of whence (defined as macros in ``stdio.h`'):

`SEEK_SET`—offset is the absolute file position (an offset from the beginning of the file) desired. offset must be positive.

`SEEK_CUR`—offset is relative to the current file position. offset can meaningfully be either positive or negative.

`SEEK_END`—offset is relative to the current end of file. offset can meaningfully be either positive (to increase the size of the file) or negative.

See `ftell`/`ftello` to determine the current file position.

Returns
`fseek`/`fseeko` return `0` when successful. On failure, the result is `EOF`. The reason for failure is indicated in `errno`: either `ESPIPE` (the stream identified by fp doesn't support repositioning) or `EINVAL` (invalid file position).

Portability
ANSI C requires `fseek`.

`fseeko` is defined by the Single Unix specification.

Supporting OS subroutines required: `close`, `fstat`, `isatty`, `lseek`, `read`, `sbrk`, `write`.